#include <avr/io.h>
#include <avr/signal.h>
#include <avr/interrupt.h>

#include "a2d.h"

void a2dInit(void)
{
	ADCSR|=(1<<ADEN);                               // enable ADC
	ADCSR&=~(1<<ADFR);                              // single sample convert mode
	a2dSetPrescaler(ADC_PRESCALE_DIV64);
	a2dSetReference(ADC_REFERENCE_AVCC);
	ADMUX&=~(1<<ADLAR);                             // zarovnat vpravo
	//sbi(ADCSR, ADIE);				// ADC prerus. zap.
}
/*
   void a2dOff(void)
   {
   	cbi(ADCSR, ADIE);				// vypni prerus
   	cbi(ADCSR, ADEN);				// vypni adc
   }
 */

void a2dSetPrescaler(unsigned char prescale)
{
	ADCSR=( (((ADCSR) &~ADC_PRESCALE_MASK) | prescale));
}

void a2dSetReference(unsigned char ref)
{
	ADMUX=( (((ADMUX) &~ADC_REFERENCE_MASK) | (ref<<6)) );
}

void a2dSetChannel(unsigned char ch)
{
	ADMUX=(((ADMUX) &~ADC_MUX_MASK) | (ch & ADC_MUX_MASK));        // nastav kanal
}

void a2dStartConvert(void)
{
	ADCSR|=1<<ADIF; // smaz flag dokonceni konverze
	ADCSR|=1<<ADATE;        // spust prevodnik
	ADCSR|=1<<ADSC; // spust prevodnik
}

unsigned short a2dConvert10bit(void)
{
	return ((ADCL) | (ADCH<<8));    // cti ADC;
}


