//---------------------------------------------------------------------------
/*
   KNIHOVNA PRO VYPOCET KOEFICIENTU DIGITALNICH BIQUAD FILTRU
   (c) Ivo Strasil 2006
   Toto neni volne siritelny software.
 */
#ifndef filterdesignH
//definice parametru filtru
typedef struct  {
	unsigned char ftype;
	unsigned int f0;
	float dbGain;
	float Q;
} filter;

//ftype
#define         FTGAIN          0
#define         FTLPF           1
#define         FTHPF           2
#define         FTBPF           3
#define         FTNOTCH         4
#define         FTAPF           5
#define         FTPEAKING       6
#define         FTLSHELF        7
#define         FTHSHELF        8

//vysledek
typedef struct  {
	float b0,b1,b2,a0,a1,a2;
} fdata;

#define         FL_OK        0
#define         FL_ERR       1


//prevod Q na Alpha
float QToAlpha(float Q, unsigned int f0);
//prevody Q na jine veliciny
float BWToQ(float BW, unsigned int f0) ;
float SToQ(float S, unsigned int f0, float dBGain) ;

unsigned char KToDb(float K);

unsigned long Fs;

//vlastni vypocet filtru
char ComputeFilter(filter * f, fdata * fd);

//vypocet modulu odezvy filtru
float FlAmp(filter f, unsigned int frequency);

//vypocet faze odezvy
float FlPha(filter f, unsigned int frequency);




#define filterdesignH
//---------------------------------------------------------------------------
#endif
