/*! \file fontgr.h \brief Graphic LCD Font (Graphic Characters). */
//*****************************************************************************
//
// File Name	: 'fontgr.h'
// Title		: Graphic LCD Font (Graphic Charaters)
// Author		: Pascal Stang
// Date			: 10/19/2001
// Revised		: 10/19/2001
// Version		: 0.1
// Target MCU	: Atmel AVR
// Editor Tabs	: 4
//
//*****************************************************************************

#ifndef FONTGR_H
#define FONTGR_H

#ifndef WIN32
// AVR specific includes
        #include <avr/pgmspace.h>
#endif

static unsigned char __attribute__ ((progmem)) FontGr[] =
{
	// format is one character per line:
	// length, byte array[length]
	0x16, 0xFF, 0xFF, 219,219,219,195,153,124,102,195,195,211,246,118,0,255,254,12,24,12,254,255,
	0x0A, 0x3C,     0x42, 0x41, 0x41, 0x41, 0x42, 0x42, 0x42, 0x3C, 0x00,   // 0. Folder Icon
	0x06, 0x0F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF                                                        // 1. Solid 6x8 block

	// 2. EGM logo
};

#endif
