#ifndef PREAMP_HW_DEF
#define PREAMP_HW_DEF

#include "a2d.h"
#include "filterdesign.h"


void TASSetupMainMix(unsigned char id);

#define g0dB    80
#define MUTEdB  0
void TASSenddB(unsigned char tasid, unsigned char parameter,unsigned char dBVal,unsigned char invert);

//adresa expanderu
#define PPEXP   64
#define TASM    0x68
#define TASS    0x6E
#define CODEC   144

//prototypy funkci

#define  LCDBackOn()            PORTA|=128;
#define  LCDBackOff()           PORTA&=~128;

//init portu + cteni hlasitosti
void InitPorts(void);
void PCMInit(void);

void InitDRC(unsigned char tasid);
void LoadDRC(unsigned char id);

void LoadSubMix(unsigned char id);
void PCMSendHID(unsigned char delta);

//ovladani desky AP

#define  APResetOn()            PORTB&=~128;
#define  APResetOff()           PORTB|=128;
#define  CodecResetOn()         PORTB&=~64;
#define  CodecResetOff()        PORTB|=64;

#define BTNPWR  4
#define BTNUP   32
#define BTNRIGHT        16
#define BTNDOWN 128
#define BTNLEFT 64
#define BTNOK   2
#define BTNROT  1


//ovladani predniho panelu

#define GetVolume()             (a2dConvert10bit())
unsigned char GetButtons(void);
void SetLed(unsigned char id);
void ResetLed(unsigned char id);
void SetRotary(unsigned char max, unsigned char value);
unsigned char GetRotary(void);
void ProcessRotary(void);

//ovladani TAS
void TASInit(void); //inicializuje i kodek
void TASSendCoef(unsigned char tasid, unsigned char parameter, fdata * fd);

//ovladani kodeku
void CSSetVolume(unsigned char out, unsigned char value);
#define CS_INA  0
#define CS_INB  1
void CSSetIn(unsigned char in);
void SetInp4(unsigned char inp4);


void RefreshVolume(void);


//cekacky
void DelayUs (unsigned char c);
void DelayMs (unsigned int c);




static unsigned char __attribute__ ((progmem)) VolTab[] =
{
	//lookup table hlasitosti

	// -oo dB
	// gain = ,0001
	// 00000346
	0x00, 0x00, 0x00, 0x00,
	// -79 dB
	// gain = ,0001
	// 000003AD
	0x00, 0x00, 0x03, 0xAD,
	// -78 dB
	// gain = ,0001
	// 00000420
	0x00, 0x00, 0x04, 0x20,
	// -77 dB
	// gain = ,0001
	// 000004A0
	0x00, 0x00, 0x04, 0xA0,
	// -76 dB
	// gain = ,0002
	// 00000531
	0x00, 0x00, 0x05, 0x31,
	// -75 dB
	// gain = ,0002
	// 000005D3
	0x00, 0x00, 0x05, 0xD3,
	// -74 dB
	// gain = ,0002
	// 00000689
	0x00, 0x00, 0x06, 0x89,
	// -73 dB
	// gain = ,0002
	// 00000755
	0x00, 0x00, 0x07, 0x55,
	// -72 dB
	// gain = ,0003
	// 0000083B
	0x00, 0x00, 0x08, 0x3B,
	// -71 dB
	// gain = ,0003
	// 0000093C
	0x00, 0x00, 0x09, 0x3C,
	// -70 dB
	// gain = ,0003
	// 00000A5C
	0x00, 0x00, 0x0A, 0x5C,
	// -69 dB
	// gain = ,0004
	// 00000BA0
	0x00, 0x00, 0x0B, 0xA0,
	// -68 dB
	// gain = ,0004
	// 00000D0B
	0x00, 0x00, 0x0D, 0x0B,
	// -67 dB
	// gain = ,0004
	// 00000EA3
	0x00, 0x00, 0x0E, 0xA3,
	// -66 dB
	// gain = ,0005
	// 0000106C
	0x00, 0x00, 0x10, 0x6C,
	// -65 dB
	// gain = ,0006
	// 0000126D
	0x00, 0x00, 0x12, 0x6D,
	// -64 dB
	// gain = ,0006
	// 000014AC
	0x00, 0x00, 0x14, 0xAC,
	// -63 dB
	// gain = ,0007
	// 00001732
	0x00, 0x00, 0x17, 0x32,
	// -62 dB
	// gain = ,0008
	// 00001A07
	0x00, 0x00, 0x1A, 0x07,
	// -61 dB
	// gain = ,0009
	// 00001D34
	0x00, 0x00, 0x1D, 0x34,
	// -60 dB
	// gain = ,001
	// 000020C4
	0x00, 0x00, 0x20, 0xC4,
	// -59 dB
	// gain = ,0011
	// 000024C4
	0x00, 0x00, 0x24, 0xC4,
	// -58 dB
	// gain = ,0013
	// 00002940
	0x00, 0x00, 0x29, 0x40,
	// -57 dB
	// gain = ,0014
	// 00002E49
	0x00, 0x00, 0x2E, 0x49,
	// -56 dB
	// gain = ,0016
	// 000033EF
	0x00, 0x00, 0x33, 0xEF,
	// -55 dB
	// gain = ,0018
	// 00003A45
	0x00, 0x00, 0x3A, 0x45,
	// -54 dB
	// gain = ,002
	// 00004161
	0x00, 0x00, 0x41, 0x61,
	// -53 dB
	// gain = ,0022
	// 0000495B
	0x00, 0x00, 0x49, 0x5B,
	// -52 dB
	// gain = ,0025
	// 0000524F
	0x00, 0x00, 0x52, 0x4F,
	// -51 dB
	// gain = ,0028
	// 00005C5A
	0x00, 0x00, 0x5C, 0x5A,
	// -50 dB
	// gain = ,0032
	// 0000679F
	0x00, 0x00, 0x67, 0x9F,
	// -49 dB
	// gain = ,0035
	// 00007443
	0x00, 0x00, 0x74, 0x43,
	// -48 dB
	// gain = ,004
	// 00008273
	0x00, 0x00, 0x82, 0x73,
	// -47 dB
	// gain = ,0045
	// 0000925E
	0x00, 0x00, 0x92, 0x5E,
	// -46 dB
	// gain = ,005
	// 0000A43A
	0x00, 0x00, 0xA4, 0x3A,
	// -45 dB
	// gain = ,0056
	// 0000B844
	0x00, 0x00, 0xB8, 0x44,
	// -44 dB
	// gain = ,0063
	// 0000CEC0
	0x00, 0x00, 0xCE, 0xC0,
	// -43 dB
	// gain = ,0071
	// 0000E7FA
	0x00, 0x00, 0xE7, 0xFA,
	// -42 dB
	// gain = ,0079
	// 00010449
	0x00, 0x01, 0x04, 0x49,
	// -41 dB
	// gain = ,0089
	// 0001240B
	0x00, 0x01, 0x24, 0x0B,
	// -40 dB
	// gain = ,01
	// 000147AE
	0x00, 0x01, 0x47, 0xAE,
	// -39 dB
	// gain = ,0112
	// 00016FA9
	0x00, 0x01, 0x6F, 0xA9,
	// -38 dB
	// gain = ,0126
	// 00019C86
	0x00, 0x01, 0x9C, 0x86,
	// -37 dB
	// gain = ,0141
	// 0001CEDC
	0x00, 0x01, 0xCE, 0xDC,
	// -36 dB
	// gain = ,0158
	// 00020756
	0x00, 0x02, 0x07, 0x56,
	// -35 dB
	// gain = ,0178
	// 000246B4
	0x00, 0x02, 0x46, 0xB4,
	// -34 dB
	// gain = ,02
	// 00028DCE
	0x00, 0x02, 0x8D, 0xCE,
	// -33 dB
	// gain = ,0224
	// 0002DD95
	0x00, 0x02, 0xDD, 0x95,
	// -32 dB
	// gain = ,0251
	// 00033718
	0x00, 0x03, 0x37, 0x18,
	// -31 dB
	// gain = ,0282
	// 00039B87
	0x00, 0x03, 0x9B, 0x87,
	// -30 dB
	// gain = ,0316
	// 00040C37
	0x00, 0x04, 0x0C, 0x37,
	// -29 dB
	// gain = ,0355
	// 00048AA7
	0x00, 0x04, 0x8A, 0xA7,
	// -28 dB
	// gain = ,0398
	// 00051884
	0x00, 0x05, 0x18, 0x84,
	// -27 dB
	// gain = ,0447
	// 0005B7B1
	0x00, 0x05, 0xB7, 0xB1,
	// -26 dB
	// gain = ,0501
	// 00066A4A
	0x00, 0x06, 0x6A, 0x4A,
	// -25 dB
	// gain = ,0562
	// 000732AE
	0x00, 0x07, 0x32, 0xAE,
	// -24 dB
	// gain = ,0631
	// 00081385
	0x00, 0x08, 0x13, 0x85,
	// -23 dB
	// gain = ,0708
	// 00090FCB
	0x00, 0x09, 0x0F, 0xCB,
	// -22 dB
	// gain = ,0794
	// 000A2ADA
	0x00, 0x0A, 0x2A, 0xDA,
	// -21 dB
	// gain = ,0891
	// 000B6873
	0x00, 0x0B, 0x68, 0x73,
	// -20 dB
	// gain = ,1
	// 000CCCCC
	0x00, 0x0C, 0xCC, 0xCC,
	// -19 dB
	// gain = ,1122
	// 000E5CA1
	0x00, 0x0E, 0x5C, 0xA1,
	// -18 dB
	// gain = ,1259
	// 00101D3F
	0x00, 0x10, 0x1D, 0x3F,
	// -17 dB
	// gain = ,1413
	// 0012149A
	0x00, 0x12, 0x14, 0x9A,
	// -16 dB
	// gain = ,1585
	// 00144960
	0x00, 0x14, 0x49, 0x60,
	// -15 dB
	// gain = ,1778
	// 0016C310
	0x00, 0x16, 0xC3, 0x10,
	// -14 dB
	// gain = ,1995
	// 00198A13
	0x00, 0x19, 0x8A, 0x13,
	// -13 dB
	// gain = ,2239
	// 001CA7D7
	0x00, 0x1C, 0xA7, 0xD7,
	// -12 dB
	// gain = ,2512
	// 002026F3
	0x00, 0x20, 0x26, 0xF3,
	// -11 dB
	// gain = ,2818
	// 00241346
	0x00, 0x24, 0x13, 0x46,
	// -10 dB
	// gain = ,3162
	// 00287A26
	0x00, 0x28, 0x7A, 0x26,
	// -9 dB
	// gain = ,3548
	// 002D6A86
	0x00, 0x2D, 0x6A, 0x86,
	// -8 dB
	// gain = ,3981
	// 0032F52C
	0x00, 0x32, 0xF5, 0x2C,
	// -7 dB
	// gain = ,4467
	// 00392CED
	0x00, 0x39, 0x2C, 0xED,
	// -6 dB
	// gain = ,5012
	// 004026E7
	0x00, 0x40, 0x26, 0xE7,
	// -5 dB
	// gain = ,5623
	// 0047FACC
	0x00, 0x47, 0xFA, 0xCC,
	// -4 dB
	// gain = ,631
	// 0050C335
	0x00, 0x50, 0xC3, 0x35,
	// -3 dB
	// gain = ,7079
	// 005A9DF7
	0x00, 0x5A, 0x9D, 0xF7,
	// -2 dB
	// gain = ,7943
	// 0065AC8C
	0x00, 0x65, 0xAC, 0x8C,
	// -1 dB
	// gain = ,8913
	// 00721482
	0x00, 0x72, 0x14, 0x82,
	// 0 dB
	// gain = 1
	// 00800000
	0x00, 0x80, 0x00, 0x00,
	// 1 dB
	// gain = 1,122
	// 008F9E4C
	0x00, 0x8F, 0x9E, 0x4C,
	// 2 dB
	// gain = 1,2589
	// 00A12477
	0x00, 0xA1, 0x24, 0x77,
	// 3 dB
	// gain = 1,4125
	// 00B4CE07
	0x00, 0xB4, 0xCE, 0x07,
	// 4 dB
	// gain = 1,5849
	// 00CADDC7
	0x00, 0xCA, 0xDD, 0xC7,
	// 5 dB
	// gain = 1,7783
	// 00E39EA8
	0x00, 0xE3, 0x9E, 0xA8,
	// 6 dB
	// gain = 1,9953
	// 00FF64C1
	0x00, 0xFF, 0x64, 0xC1,
	// 7 dB
	// gain = 2,2387
	// 011E8E6A
	0x01, 0x1E, 0x8E, 0x6A,
	// 8 dB
	// gain = 2,5119
	// 0141857E
	0x01, 0x41, 0x85, 0x7E,
	// 9 dB
	// gain = 2,8184
	// 0168C0C5
	0x01, 0x68, 0xC0, 0xC5,
	// 10 dB
	// gain = 3,1623
	// 0194C583
	0x01, 0x94, 0xC5, 0x83,
	// 11 dB
	// gain = 3,5481
	// 01C62940
	0x01, 0xC6, 0x29, 0x40,
	// 12 dB
	// gain = 3,9811
	// 01FD93C1
	0x01, 0xFD, 0x93, 0xC1,
	// 13 dB
	// gain = 4,4668
	// 023BC147
	0x02, 0x3B, 0xC1, 0x47,
	// 14 dB
	// gain = 5,0119
	// 02818508
	0x02, 0x81, 0x85, 0x08,
	// 15 dB
	// gain = 5,6234
	// 02CFCC01
	0x02, 0xCF, 0xCC, 0x01,
	// 16 dB
	// gain = 6,3096
	// 0327A01A
	0x03, 0x27, 0xA0, 0x1A,
	// 17 dB
	// gain = 7,0795
	// 038A2BAC
	0x03, 0x8A, 0x2B, 0xAC,
	// 18 dB
	// gain = 7,9433
	// 03F8BD79
	0x03, 0xF8, 0xBD, 0x79,
	// 19 dB
	// gain = 8,9125
	// 0474CD1B
	0x04, 0x74, 0xCD, 0x1B,
	// 20 dB
	// gain = 10
	// 05000000
	0x05, 0x00, 0x00, 0x00
};


#endif
