#ifndef PREAMP_INTF
#define PREAMP_INTF

#include "glcd.h"
#include "filterdesign.h"

#define VERZEFW "1.00"

/// nastaveni biquadu ///

filter maineq[24];
filter subeq[2*16];

void BiquadEdit(filter * f, unsigned char fi1, unsigned char fi2, unsigned char id);
void MainEQEdit(unsigned char id);

void SaveEq(unsigned char id, unsigned char position) ;
void LoadEq(unsigned char id, unsigned char position) ;


typedef struct tvb {
	unsigned char volume;
	unsigned char balance;
} vb;

#define REZ_STEREO                      0
#define REZ_MONO                        1

/*
 #define REZ_DUALMONO_LR		2
 #define REZ_DUALMONO_SUM	3
 */


#define CHANNEL_SWAP    32

#define PH_INV_L        64
#define PH_INV_R        128

#define REZ_EXTCHAN     16

typedef struct tvbrezim {
	unsigned char volume;
	unsigned char balance;
	unsigned char flags;
} vbrezim;

void SetupMenu(void);

#define PV_VV           0       /* vedl. vystup */
#define PV_STRHV        1       /* stred hl.vyst. */
#define PV_HV           2       /* odp. hl.vystup */

#define LEFT                                    0
#define RIGHT                                   1

#define MONOMIX                                 2
#define MONOMIX_INV                             3
#define MONOMIX_VOCALS_REMOVE   4

#define INP0    0
#define INP1    1
#define INP2    2
#define INP_USB 3

typedef struct {
	//hlavni vystup
	unsigned char gain[18];
	unsigned char monoset[9];
	unsigned short invflags;
} t_sub_mix_struct  ;
t_sub_mix_struct submix[2];

unsigned char volset;

typedef struct {
	//hlavni vystup
	vbrezim inpmix[4];
	unsigned char PVOutRezim[2]; //rezerva
} t_main_mix_struct  ;
t_main_mix_struct mainmix[2];

typedef struct {
	unsigned char slopeL, slopeH;
	unsigned char treshold[2];
	unsigned char offset[2];
	unsigned char speed;
} t_drc_struct ;
t_drc_struct drcset[4];

void DRCEdit(unsigned char id);
void LoadDRCFromEE(unsigned char id, unsigned char position) ;
void SaveDRCToEE(unsigned char id, unsigned char position) ;

/*

   struct t_sub_mix_struct {
   vb PVUSBMix;
   unsigned char PVInp;
   unsigned char PVInpRezim;
   } submix[2];

 */
void MainMixEdit(unsigned char id);
void SubMixEdit(unsigned char id);
void SaveMainMix(unsigned char id, unsigned char position);
void LoadMainMix(unsigned char id, unsigned char position);
void LoadSubEq(unsigned char id, unsigned char position);
void LoadSubMixFromEE(unsigned char id, unsigned char position);
unsigned char SelectNumber(unsigned char id, unsigned char max);

#endif
